#include <cstdio>
#include <cstdlib>
#include <climits>
#include <cmath>
#include <queue>

#define min(a,b) (a < b ? a : b)

using namespace std;

const static int SIZE=1010;
const static int UNDEF= -1;
//const static int TARGET=1009;

enum{FRESH, CLOSED, OPEN};

int m[SIZE][SIZE];
int f[SIZE][SIZE];
int p[SIZE];
int d[SIZE];
int deg[SIZE]; //deg(out)
int c,n;
int stav[SIZE];
int TARGET = 0;

bool Load(){
    if (scanf("%d %d", &n, &c ) != 2)
        return false;

    for(int i = 0;i < SIZE; i++)
    {
        deg[i] = 0;
        for(int j = 0; j< SIZE; j++)
            m[i][j]=UNDEF;
    }
    for (int i = 0; i < n-1; i++)
    {
        int val, u ,v;
        scanf("%d %d %d", &u, &v, &val);
        m[u][v]=val;
        m[v][u]=val;
        deg[u] += 1;
        deg[v] += 1;
    }
	//n += 1;
	//TARGET=n;

    for (int i=0; i <=n; i++)
    {
        if (deg[i]==1 && i!= c && i!=TARGET)
        {
            m[i][TARGET]=INT_MAX;
            m[TARGET][i]=INT_MAX;
        }
    }
    return true;
}

int findOpen(){
    for(int i=0; i <=n;i++)
        if (stav[i]==OPEN)
            return i;
    return -1;
}

bool cesta()
{
    for(int i=0; i <= n; i++)
        stav[i] = FRESH;

    p[c] = TARGET;
    d[c] = INT_MAX;
    stav[c] = OPEN;
    int u;

    do{
        u = findOpen();
        if (u<0) break;

        stav[u] = CLOSED;
        for(int i=0; i<=n; i++)
        {
            // pro vsecky nasledniky
            if(! (m[u][i]>=0))
                continue;

            int v=i;

            if (stav[v]==FRESH && f[u][v] < m[u][v])
            {
                stav[v] = OPEN;
                p[v] = u;
                d[v] = min(d[u], m[u][v]-f[u][v]);
            }

        }
        for(int i=0; i<=n; i++)
        {
            //pro vsechny predchudce
            int v=i;
            if (! (m[i][u]>=0) )
                continue;
            if (stav[v]==FRESH && f[u][v]>0)
            {
                stav[v]=OPEN;
                p[v]=-u;
                d[v]=min(d[u],f[u][v]);
            }
        }
    }
    while( u != TARGET);

    return u==TARGET;
}

void zvystok()
{
printf("----");
for(int i=0; i<=n; i++)
printf("%d ", d[i]);
printf("\n");

    int x = TARGET;
    int delta = d[TARGET];

    int v;
    int u=p[x];
    do
    {
        v = x;
        if(p[x] == +u)
            f[u][v]+=delta;
        else
            f[v][u]-= delta;
        

    }
    while(v != c);
}


void fordf()
{
    for(int i=0; i<=n; i++)
        for(int j=0; j<=n; j++)
            f[i][j]=0;

    while(cesta())
        zvystok();

	for(int i=0; i<=n; i++)
	{
        	for(int j=0; j<=n; j++)
			printf("%d ", f[i][j]); 		
		printf("\n");
	}
}

void orientuj()
{
    for(int i=0; i<=n; i++)
        stav[i]=FRESH;

    std::queue<int> q;
    int u=c;
    stav[u]=OPEN;
    q.push(u);
    while(!q.empty())
    {
        u = q.front();
        q.pop();

        for(int i=0; i<=n; i++)
        {
            if(stav[i]==FRESH)
            {
                stav[i]=OPEN;
                m[i][u]=-1;
                q.push(i);
            }
        }
    }
}

int flow()
{
    orientuj();
    fordf();
    return 1;
}

int main()
{

    while (Load())
    {
	flow();
        int fl= 0;
        for(int i=1;i<=n; i++)
        {
            fl+=f[c][i];
        }
        printf("%d\n", fl);
    }
        //printf("%d\n", flow());
  
  return 0;
}
